package org.herac.tuxguitar.gui.system.plugins.base;

import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.gui.tools.browser.TGBrowserManager;
import org.herac.tuxguitar.gui.tools.browser.base.TGBrowserFactory;

public abstract class TGBrowserPlugin extends TGPluginBase{
	private boolean loaded;
	private TGBrowserFactory factory;

	protected abstract TGBrowserFactory getFactory();
	
	public void init(TuxGuitar instance) {
		this.factory = getFactory();
		this.loaded = false;
	}

	public void close() {
		this.loaded = false;
	}

	protected void addPluin(){
		if(!this.loaded){
			TGBrowserManager.instance().addFactory(this.factory);
			this.loaded = true;
		}
	}
	
	protected void removePluin(){		
		if(this.loaded){
			TGBrowserManager.instance().removeFactory(this.factory);
			this.loaded = false;
		}
	}	

	public void setEnabled(boolean enabled) {
		if(enabled){
			addPluin();
		}else{
			removePluin();
		}
	}	
}
