package org.herac.tuxguitar.gui.system.plugins.base;

import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.io.base.TGFileFormatManager;
import org.herac.tuxguitar.io.base.TGSongExporter;

public abstract class TGExporterPlugin extends TGPluginBase{
	
	private boolean loaded;
	private TGSongExporter exporter;
	
	protected abstract TGSongExporter getExporter();
	
	public void init(TuxGuitar instance){
		this.exporter = getExporter();
	}
	
	public void close(){
		this.removePluin();
	}
	
	protected void addPluin(){		
		if(!this.loaded){
			TGFileFormatManager.instance().addExporter(this.exporter);
			TuxGuitar.instance().getItemManager().createMenu();
			this.loaded = true;
		}
	}
	
	protected void removePluin(){		
		if(this.loaded){
			TGFileFormatManager.instance().removeExporter(this.exporter);
			TuxGuitar.instance().getItemManager().createMenu();
			this.loaded = false;
		}
	}
	
	public void setEnabled(boolean enabled) {
		if(enabled){
			addPluin();
		}else{
			removePluin();
		}
	}	
	
}
