package org.herac.tuxguitar.gui.system.plugins.base;

import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.io.base.TGFileFormatManager;
import org.herac.tuxguitar.io.base.TGSongImporter;

public abstract class TGImporterPlugin extends TGPluginBase{

	private boolean loaded;
	private TGSongImporter importer;
	
	protected abstract TGSongImporter getImporter();
	
	public void init(TuxGuitar instance){
		this.importer = getImporter();
	}
	
	public void close(){
		this.removePluin();
	}
	
	protected void addPluin(){
		if(!this.loaded){
			TGFileFormatManager.instance().addImporter(this.importer);
			TuxGuitar.instance().getItemManager().createMenu();
			this.loaded = true;
		}				
	}
	
	protected void removePluin(){		
		if(this.loaded){
			TGFileFormatManager.instance().removeImporter(this.importer);
			TuxGuitar.instance().getItemManager().createMenu();
			this.loaded = false;
		}		
	}
	
	public void setEnabled(boolean enabled) {
		if(enabled){
			addPluin();
		}else{
			removePluin();
		}
	}
	
}
