package org.herac.tuxguitar.gui.system.plugins.base;

import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.io.base.TGFileFormatManager;
import org.herac.tuxguitar.io.base.TGInputStreamBase;

public abstract class TGInputStreamPlugin extends TGPluginBase{

	private boolean loaded;
	private TGInputStreamBase stream;
	
	protected abstract TGInputStreamBase getInputStream();
	
	public void init(TuxGuitar instance){
		this.stream = getInputStream();
	}
	
	public void close(){
		this.removePluin();
	}
	
	protected void addPluin(){
		if(!this.loaded){
			TGFileFormatManager.instance().addInputStream(this.stream);
			this.loaded = true;
		}
	}
	
	protected void removePluin(){		
		if(this.loaded){
			TGFileFormatManager.instance().removeInputStream(this.stream);
			this.loaded = false;
		}
	}

	public void setEnabled(boolean enabled) {
		if(enabled){
			addPluin();
		}else{
			removePluin();
		}
	}		
	
}
