package org.herac.tuxguitar.gui.system.plugins.base;

import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.io.base.TGFileFormatManager;
import org.herac.tuxguitar.io.base.TGOutputStreamBase;

public abstract class TGOutputStreamPlugin extends TGPluginBase{
	
	private boolean loaded;
	private TGOutputStreamBase stream;
	
	protected abstract TGOutputStreamBase getOutputStream();
	
	public void init(TuxGuitar instance){
		this.stream = getOutputStream();
	}
	
	public void close(){
		this.removePluin();
	}
	
	protected void addPluin(){
		if(!this.loaded){
			TGFileFormatManager.instance().addOutputStream(this.stream);
			this.loaded = true;
		}
	}
	
	protected void removePluin(){		
		if(this.loaded){
			TGFileFormatManager.instance().removeOutputStream(this.stream);
			this.loaded = false;
		}			
	}

	public void setEnabled(boolean enabled) {
		if(enabled){
			addPluin();
		}else{
			removePluin();
		}
	}	
}
